<?php

namespace LakeDrops\Docker4Drupal;

use Composer\Script\Event;
use Composer\Script\ScriptEvents;
use LakeDrops\Component\Composer\BasePlugin;

/**
 * Composer plugin for handling docker4drupal setup.
 */
class Plugin extends BasePlugin {

  /**
   * {@inheritdoc}
   */
  public function getHandlerClass() {
    return Handler::class;
  }

  /**
   * {@inheritdoc}
   */
  public static function getSubscribedEvents() {
    return array(
      ScriptEvents::POST_CREATE_PROJECT_CMD => 'configureProject',
      ScriptEvents::POST_INSTALL_CMD => 'configureProject',
      ScriptEvents::POST_UPDATE_CMD => 'configureProject',
    );
  }

  /**
   * Configure project event callback.
   *
   * @param \Composer\Script\Event $event
   *   The event that triggered the call of this function.
   */
  public function configureProject(Event $event) {
    $this->handler->configureProject($event);
  }

  /**
   * Script callback for putting in composer scripts to configure the project.
   *
   * @param \Composer\Script\Event $event
   *   The event that triggered the call of this function.
   *
   * @throws \Twig_Error_Loader
   * @throws \Twig_Error_Runtime
   * @throws \Twig_Error_Syntax
   */
  public static function config(Event $event) {
    $handler = new Handler($event->getComposer(), $event->getIO());
    $handler->configureProject($event, TRUE);
  }

}
